import java.util.Map;

void setup() {
  size(width, height);
  background(WHITE);
  noStroke();

  fontItalic =loadFont("HelveticaNeue-LightItalic-14.vlw");
  fontItalicSmall=loadFont("HelveticaNeue-LightItalic-12.vlw");

  
  for(int a=0; a<topBaseball.length; a++) { topBaseball[a] = dummy; topBasketball[a] = dummy; topFootball[a] = dummy; }

  footb = new Record();
  basketb = new Record();
  baseb = new Record();
  
   /*
  println("Starting Queries");
  for(int mnth=0; mnth<startDates.length; mnth++ ) {
    int ans = superSetup(baseb, "mariners", "baseball", startDates[mnth], endDates[mnth]);
    data[floor(mnth/12)][mnth%12] = ans;
  } println("Finished Queries");
  
  println("Starting Queries");
  for(int mnth=0; mnth<startDates.length; mnth++ ) {
    int ans = superSetup(basketb, "supersonics", "basketball", startDates[mnth], endDates[mnth]);
    data[floor(mnth/12)][mnth%12] = ans;
  } println("Finished Queries");
  
  println("Starting Queries");
  for(int mnth=0; mnth<startDates.length; mnth++ ) {
    int ans = superSetup(footb, "seahawks", "football", startDates[mnth], endDates[mnth]);
    data[floor(mnth/12)][mnth%12] = ans;
  } println("Finished Queries");
  */
 /* println("PRINTING DATA");
  for(int j=0; j<years.length; j++) {
      for(int i=0; i<12; i++) print( data[j][i] +", ");
      println();
  }*/
  //println("PRINTING OF DATA FINISH");
/*
  for( String key : footb.map.keySet() ) {
    Micro node = footb.map.get(key);
    if(node!=null) println( "W> "+ node.keyword +" C> "+ node.count);
  }
  
  Micro ma = footb.getMax();
  println("MAX IS "+ ma.count +" AND "+ ma.keyword);
  */
  int max=0;
  String book;
  
  tt = new Table();
  
  for(int file=0; file<fileNames.length; file++) {
    tt = loadTable(fileNames[file]);
    nRow = tt.getRowCount();
    nCol = tt.getColumnCount();
    if(D) println("nR " + nRow + " nC " + nCol); 
    
    String title, subj, mediaT;
    int total=0, higher_total=0;
    int [] buff_book = new int[years.length];
    int [] buff_yearly = new int[years.length];
    Reading current = null;
    
    for(int r=1; r<nRow; r++) {
       title = tt.getString(r,0);
       subj = tt.getString(r,1);
       mediaT = tt.getString(r,2);
       total = tt.getInt(r,3);

       if(D) println("TITLE "+ title +" TOTAL "+ total);
       higher_total += total;
       
       if(D) print("BOOK BUFF// ");
       for(int i=0; i<buff_book.length; i++) {
          int val = tt.getInt(r,i+4);
          buff_book[i] = val;
          buff_yearly[i] += val;
          if(D) print(val +" ");
       } 
       if(D) println();
       
       
       if(D) print("WEEKLY BUFF// ");
       for(int i=0; i<buff_yearly.length; i++) {
          if(D) print(buff_yearly[i] +" ");
       } 
       if(D) println();
        
      if(file>= 0 && file<= 2) {
        generalBaseball.addBook(title, subj, mediaT, buff_book, total);  
        if(file==0) generalBaseball.setNumberOfBooks(nRow); 
        if(total >= maxBase) { generalBaseball.setMaxCout(total); maxBase = total; }
      } else if(file>= 3 && file<= 5) {
        generalBasketball.addBook(title, subj, mediaT, buff_book, total); 
        if(file==3) generalBasketball.setNumberOfBooks(nRow);
        if(total >= maxBasket) { generalBasketball.setMaxCout(total); maxBasket = total; }    
      } else if(file>= 6 && file<= 8) {
        generalFootball.addBook(title, subj, mediaT, buff_book, total); 
        if(file==6) generalFootball.setNumberOfBooks(nRow); 
        if(total >= maxFoot) { generalFootball.setMaxCout(total); maxFoot = total; }     
      } 
      
      total = 0;
      for(int q=0;q<buff_book.length;q++) buff_book[q] = 0;
    } //ENDS ROW LOOP
   
    if(D) {
      println("FINISHED FILE " + file + " and my buff_yearly is");
      for(int q=0;q<buff_yearly.length;q++) print( buff_yearly[q] + ", ");
      println("HIGHER TOTAL "+ higher_total);
    }
    
    switch(file) {
      case 0:  baseball.setCheckouts(buff_yearly, higher_total ); break;
      case 1:  mlb.setCheckouts(buff_yearly, higher_total ); break;
      case 2:  mariners.setCheckouts(buff_yearly, higher_total ); break;
      case 3:  basketball.setCheckouts(buff_yearly, higher_total ); break;
      case 4:  nba.setCheckouts(buff_yearly, higher_total ); break;
      case 5:  supersonics.setCheckouts(buff_yearly, higher_total ); break;
      case 6:  football.setCheckouts(buff_yearly, higher_total ); break;
      case 7:  nfl.setCheckouts(buff_yearly, higher_total ); break;
      case 8:  seahawks.setCheckouts(buff_yearly, higher_total ); break;
    }
   
    
    higher_total = 0;
    for(int q=0;q<buff_yearly.length;q++) buff_yearly[q] = 0;
    if(D) println("!!!! finished full file !!!!");
   } //ENDS FILE LENGTH LOOP
  
  
  int son=0, mar=0, sea=0;
  for(int i=0; i<years.length; i++) {
    for(int j=0; j<12; j++) {
      mar += dataMariners[i][j];
      son += dataSupersonics[i][j];
      sea += dataSeahawks[i][j];
    }
    yearlySonics[i] = son;
    yearlyMariners[i] = mar;
    yearlySeahawks[i] = sea;
    son = 0; mar = 0; sea = 0;
  }
  
  /*
  println("Sonics");
   for(int i=0; i<years.length; i++) {
    print(yearlySonics[i] +", ");
  } println();
  
   println("Seahawks");
   for(int i=0; i<years.length; i++) {
    print(yearlySeahawks[i] +", ");
  } println();
  
   println("Mariners");
   for(int i=0; i<years.length; i++) {
    print(yearlyMariners[i] +", ");
  } println();
  */
  
  populatePopularAlltime(generalBaseball, topBaseball);
  //for(int a=0; a<topBaseball.length; a++) topBaseball[a].printSelf();
  
  populatePopularAlltime(generalBasketball, topBasketball);
  //for(int a=0; a<topBasketball.length; a++) topBasketball[a].printSelf();
  
  populatePopularAlltime(generalFootball, topFootball);
  //for(int a=0; a<topFootball.length; a++) topFootball[a].printSelf();
  
  populatePopularAlltime2(baseb, topBaseb);
  populatePopularAlltime2(basketb, topBasketb);
  populatePopularAlltime2(footb, topFootb);

  
  for(int abc=0;abc<years.length;abc++) {
     populatePopularYear(abc, generalBaseball, 0);
  }   
  
  for(int abc=0;abc<years.length;abc++) {
     populatePopularYear(abc, generalBasketball, 1);
  }  
  for(int abc=0;abc<years.length;abc++) {
     populatePopularYear(abc, generalFootball, 2);
  }  
  
  maxBase = generalBaseball.maxCout;
  maxBasket = generalBasketball.maxCout;
  maxFoot = generalFootball.maxCout;
  
}



  
public void populatePopularAlltime(Sport sport, Reading[] top) {
  for( String key : sport.readings.keySet() ) {
    int couts = sport.readings.get(key).couts; 
    if(couts > top[5].couts) {
      if(couts >= top[0].couts) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = top[0];
       top[0] = sport.readings.get(key); 
      } else if(couts >= top[1].couts) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = sport.readings.get(key);
      } else if(couts >= top[2].couts) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = sport.readings.get(key);
      } else if(couts >= top[3].couts) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = sport.readings.get(key);
      } else if(couts >= top[4].couts) {
       top[5] = top[4];
       top[4] = sport.readings.get(key);
      } else if(couts >= top[5].couts) {
       top[5] = sport.readings.get(key);
      }
      
    }
  } //ENDS FOR KEYS IN KEYSET
}



 
public void populatePopularAlltime2(Record sport, Micro[] top) {
  for( String key : sport.map.keySet() ) {
    int couts = sport.map.get(key).count; 
    if(couts > top[5].count) {
      if(couts >= top[0].count) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = top[0];
       top[0] = sport.map.get(key); 
      } else if(couts >= top[1].count) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = sport.map.get(key);
      } else if(couts >= top[2].count) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = sport.map.get(key);
      } else if(couts >= top[3].count) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = sport.map.get(key);
      } else if(couts >= top[4].count) {
       top[5] = top[4];
       top[4] = sport.map.get(key);
      } else if(couts >= top[5].count) {
       top[5] = sport.map.get(key);
      }
      
    }
  } //ENDS FOR KEYS IN KEYSET
}



public void populatePopularYear(int yr, Sport sport, int sprt) {
  Reading[] top = new Reading[6];
  for(int a=0; a<top.length; a++) top[a] = dummy;
  
  for( String key : sport.readings.keySet() ) {
    int couts = sport.readings.get(key).yearly[yr]; 
    if(couts > top[5].yearly[yr]) {
      if(couts >= top[0].yearly[yr]) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = top[0];
       top[0] = sport.readings.get(key); 
      } else if(couts >= top[1].yearly[yr]) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = top[1];
       top[1] = sport.readings.get(key);
      } else if(couts >= top[2].yearly[yr]) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = top[2];
       top[2] = sport.readings.get(key);
      } else if(couts >= top[3].yearly[yr]) {
       top[5] = top[4];
       top[4] = top[3];
       top[3] = sport.readings.get(key);
      } else if(couts >= top[4].yearly[yr]) {
       top[5] = top[4];
       top[4] = sport.readings.get(key);
      } else if(couts >= top[5].yearly[yr]) {
       top[5] = sport.readings.get(key);
      }
      
    }
  } //ENDS FOR KEYS IN KEYSET
  
  for(int def=0;def<top.length-1;def++) {
    popularityInstance[sprt][yr][def] = top[def];
  }
  
  
}

